#ifndef MSP_GLTK_LINEARARRANGEMENT_H_
#define MSP_GLTK_LINEARARRANGEMENT_H_

#include <msp/datafile/objectloader.h>
#include "arrangement.h"

namespace Msp {
namespace GLtk {

class LinearArrangement: public Arrangement
{
public:
	class Loader: public DataFile::ObjectLoader<LinearArrangement>
	{
	public:
		Loader(LinearArrangement &);
	private:
		void expand();
		void split();
	};

protected:
	Side primary;
	Side opposite;
	Edge next;
	bool first;
	bool split_here;
	Side gravity;

	LinearArrangement(Layout &, Side);

public:
	void split();
	void expand();

protected:
	virtual void process_widget(Widget &, Side, bool);
	virtual void finish_slot();
};

} // namespace GLtk
} // namespace Msp

#endif
